package cc.fascinated.bat.command;

import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.user.BatUser;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.concrete.TextChannel;
import net.dv8tion.jda.api.interactions.commands.OptionMapping;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;

/**
 * @author Fascinated (fascinated7)
 */
public interface BatCommandExecutor {

    /**
     * Executes the command using a slash command interaction.
     *
     * @param guild the bat guild the command was executed in
     * @param user the bat user that executed the command
     * @param channel the channel the command was executed in
     * @param member the member that executed the command
     * @param interaction the slash command interaction
     * @param option the option that was used in the command, or null if no option was used
     */
    default void execute(
            @NonNull BatGuild guild,
            @NonNull BatUser user,
            @NonNull TextChannel channel,
            @NonNull Member member,
            @NonNull SlashCommandInteraction interaction,
            OptionMapping option
    ) {}
}
