package cc.fascinated.bat.command.impl.global.beatsaber.scoresaber;

import cc.fascinated.bat.command.BatSubCommand;
import cc.fascinated.bat.model.BatGuild;
import cc.fascinated.bat.model.user.BatUser;
import cc.fascinated.bat.service.ScoreSaberService;
import cc.fascinated.bat.service.UserService;
import lombok.NonNull;
import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.channel.concrete.TextChannel;
import net.dv8tion.jda.api.interactions.commands.OptionMapping;
import net.dv8tion.jda.api.interactions.commands.SlashCommandInteraction;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author Fascinated (fascinated7)
 */
@Component
public class UserSubCommand extends BatSubCommand {
    private final ScoreSaberService scoreSaberService;
    private final UserService userService;

    @Autowired
    public UserSubCommand(@NonNull ScoreSaberService scoreSaberService, @NonNull UserService userService) {
        this.scoreSaberService = scoreSaberService;
        this.userService = userService;
    }

    @Override
    public void execute(@NonNull BatGuild guild, @NonNull BatUser user, @NonNull TextChannel channel, @NonNull Member member, @NonNull SlashCommandInteraction interaction, OptionMapping option) {
        BatUser target = userService.getUser(option.getAsUser().getId());
        if (target == null) {
            interaction.reply("User not found").queue();
            return;
        }

        ScoreSaberCommand.sendProfileEmbed(false, target, scoreSaberService, interaction);
    }
}
