package cc.fascinated.bat.model;

import cc.fascinated.bat.service.DiscordService;
import lombok.Getter;
import lombok.NonNull;
import lombok.RequiredArgsConstructor;
import lombok.Setter;
import net.dv8tion.jda.api.entities.Guild;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;

/**
 * @author Fascinated (fascinated7)
 */
@RequiredArgsConstructor
@Getter @Setter
@Document(collection = "guilds")
public class BatGuild {

    /**
     * The ID of the guild
     */
    @NonNull @Id private final String id;

    /**
     * Gets the guild as the JDA Guild
     *
     * @return the guild
     */
    private Guild getDiscordGuild() {
        return DiscordService.JDA.getGuildById(id);
    }
}
